/**
 * ResultCodeMap.java
 * Created on 2003/06/02
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Must not change/append/modify this list of conditions and the 
 *    following disclaimer, if you altered this source code.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package net.prixdami.alexis.system;

import java.util.HashMap;

import net.prixdami.alexis.model.ResultModel;

public final class ResultCodeMap {

        private ResultCodeMap() {};
        private static final HashMap codeinfo = new HashMap();
        static {
                setCode("satisfyTo", ResultModel.SATISFY);
                setCode("noticeTo", ResultModel.NOTICE);
                setCode("fatalTo", ResultModel.FATAL);
                setCode("errorTo", ResultModel.ERROR);
        }

        public static int getCode(String key) {
                return ((Integer) codeinfo.get(key)).intValue();
        }

        public static void setCode(String key, int value) throws IllegalArgumentException {
                Integer val = new Integer(value);
                if (codeinfo.containsValue(val)) {
                        throw new IllegalArgumentException("Value " + val + " is already exsit");
                }
                codeinfo.put(key, val);
        }
}
